﻿Type=Service
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	'YT
	Public LVLlinks As List
	Public NextPageToken As String
	'Public out As OutputStream
	Public out1 As OutputStream
	Public k As Int
	Dim parser As Parser
	
	'DB
	Dim VIDEODB As SQL
	Dim media_url As String
	Dim TitleVid  As String
	Dim VidID As String
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.

	'YT
	LVLlinks.Initialize
	LVLlinks.Clear
	'DB

		'check if the database already exists
	If File.Exists(File.DirDefaultExternal, "videos.db") = False Then
		'copy the default DB
		File.Copy(File.DirAssets, "videos.db", File.DirDefaultExternal, "videos.db")
		'if not, initialize it 
		VIDEODB.Initialize(File.DirDefaultExternal, "videos.db", True)

	Else
		'if yes, initialize it
		VIDEODB.Initialize(File.DirDefaultExternal, "videos.db", True)
	End If





End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

Private Sub YTimgRequest(arr() As String)
	
    Dim URLtoGET As String = arr(0)
	
	Dim S() As String = Regex.Split(":", URLtoGET)
	Dim URLtoGET1 As String = "http:"&S (1)
    Log("this is the url to get: " & URLtoGET)
	Log("this is the url to get 1: " & URLtoGET1)
    
    Dim J As HttpJob
        J.Initialize("JobImageDownload", Me)
        J.Download (URLtoGET1)
        J.GetRequest.SetHeader("Connection", "Keep-Alive")     
		J.tag = Array As String(arr(1), arr(2)) 
    Log("Downloading Image")
End Sub

Sub JobDone (Job As HttpJob)
    
Dim JobResult As Object
	Dim out As OutputStream
   Log("JobName = " & Job.JobName & ", Success = " & Job.Success)
    If Job.Success = True And Job.JobName = "JobImageDownload" Then
        JobResult = Job.GetInputStream
           out.InitializeToBytesArray(10000)     
           File.Copy2(JobResult, out)
           out.close
		   
		   k=k+1
		   
		   'Put the images in a folder for download stream controll(to be commented later)
		out1 = File.OpenOutput(File.DirDefaultExternal & "/img/", K &".jpg",False )
		File.Copy2(Job.GetInputStream, out1)
		out1.Close
		Dim ImgURLfin As String = File.DirDefaultExternal & "/img/" & K & ".jpg"

	'Put data in the Database
        VIDEODB.BeginTransaction
        Try
        Dim s() As String 'define the array
        s = Job.tag'get it from tag
'VIDEODB.ExecNonQuery2("INSERT INTO vid VALUES(?, ?, ?, ?)", Array As Object(Null,out,s(0),s(1)))  'original wrong
		
		Dim b() As Byte = Bit.InputStreamToBytes(Job.GetInputStream)	
      	VIDEODB.ExecNonQuery2("INSERT INTO vid VALUES(?, ?, ?, ?)", Array As Object(Null,b,s(0),s(1)))

        VIDEODB.TransactionSuccessful
        Catch
        Log(LastException.Message)
        End Try
        VIDEODB.EndTransaction
     
         Job.Release 
    Else
      Log("Error: " & Job.ErrorMessage)
      ToastMessageShow("Error: " & Job.ErrorMessage, True)
   End If

   Job.Release
   	Log("i = " & Main.i)
		Log("K = " & k)
   If k = Main.i Then
   	Log("DOWNLOAD FINISHED!")

   End If
End Sub

